Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
var ABTab = {

    init: function()
	{

 	},

	MyDisplayCardViewPane: function(realCard)
	{
		var generatedName = realCard.generateName(Services.prefs.getIntPref("mail.addr_book.lastnamefirst"));

		// This will become neater when bug 312116 is fixed...
		// (card.property instead of card.getProperty("Property"))
		var card = { getProperty : function (prop) {
                	return realCard.getProperty(prop, "");
               		},
			primaryEmail : realCard.primaryEmail,
            		displayName : realCard.displayName,
            		isMailList : realCard.isMailList,
            		mailListURI : realCard.mailListURI,
		};

		var data = cvData;
		var visible;

		// Contact photo
		displayPhoto(card, cvData.cvPhoto);

		var titleString;
		if (generatedName == "")
			titleString = card.primaryEmail;  // if no generatedName, use email
		else
			titleString = generatedName;

		// set fields in card view pane
		if (card.isMailList)
			cvSetNode(data.CardTitle, gAddressBookBundle.getFormattedString("viewListTitle", [generatedName]));
		else
			cvSetNode(data.CardTitle, titleString);

		// Contact section
		cvSetNodeWithLabel(data.cvNickname, zNickname, card.getProperty("NickName"));

		if (card.isMailList) 
		{
			// email1, display name and screenname always hidden when a mailing list.
			cvSetVisible(data.cvDisplayName, false);
			cvSetVisible(data.cvEmail1Box, false);
			cvSetVisible(data.cvScreennameBox, false);

			visible = HandleLink(data.cvListName, zListName, card.displayName, data.cvListNameBox, "mailto:" + encodeURIComponent(GenerateAddressFromCard(card))) || visible;
		}
		else 
		{
			// listname always hidden if not a mailing list
			cvSetVisible(data.cvListNameBox, false);

			cvSetNodeWithLabel(data.cvDisplayName, zDisplayName, card.displayName);

			visible = HandleLink(data.cvEmail1, zPrimaryEmail, card.primaryEmail, data.cvEmail1Box, "mailto:" + card.primaryEmail) || visible;
		}

  		visible = HandleLink(data.cvEmail2, zSecondaryEmail, card.getProperty("SecondEmail"), data.cvEmail2Box, "mailto:" + card.getProperty("SecondEmail")) || visible;

   		// Home section
   		visible = cvSetNode(data.cvHomeAddress, card.getProperty("HomeAddress"));
   		visible = cvSetNode(data.cvHomeAddress2, card.getProperty("HomeAddress2")) || visible;
   		visible = cvSetCityStateZip(data.cvHomeCityStZip, card.getProperty("HomeCity"), card.getProperty("HomeState"), card.getProperty("HomeZipCode")) || visible;
   		visible = cvSetNode(data.cvHomeCountry, card.getProperty("HomeCountry")) || visible;
   		if (visible) 
		{
			var homeMapItUrl = CreateMapItURL(card.getProperty("HomeAddress"), card.getProperty("HomeAddress2"), card.getProperty("HomeCity"), card.getProperty("HomeState"), card.getProperty("HomeZipCode"),card.getProperty("HomeCountry"));
    			if (homeMapItUrl) 
			{
       				cvSetVisible(data.cvbHomeMapItBox, true);
       				data.cvHomeMapIt.setAttribute('url', homeMapItUrl);
    			} 
			else 
			{
     				cvSetVisible(data.cvbHomeMapItBox, false);
			}
  		} 
		else 
		{
    			cvSetVisible(data.cvbHomeMapItBox, false);
  		}

  		visible = HandleLink(data.cvHomeWebPage, "", card.getProperty("WebPage2"), data.cvHomeWebPageBox, card.getProperty("WebPage2")) || visible;
  		cvSetVisible(data.cvhHome, visible);
  		cvSetVisible(data.cvbHome, visible);
  		if (card.isMailList) 
		{
    			// Description section
    			visible = cvSetNode(data.cvDescription, card.getProperty("Notes"));
    			cvSetVisible(data.cvbDescription, visible);

    			// Addresses section
    			visible = cvAddAddressNodes(data.cvAddresses, card.mailListURI);
    			cvSetVisible(data.cvbAddresses, visible);

    			// Other and Chat sections, not shown for mailing lists.
    			cvSetVisible(data.cvbOther, false);
    			cvSetVisible(data.cvbChat, false);
  		}
  		else 
		{
    			// Other section
    			// setup the birthday information
    			var day = card.getProperty("BirthDay", null);
    			var month = card.getProperty("BirthMonth", null);
    			var year = card.getProperty("BirthYear", null);
    			var dateStr;
    			if (day > 0 && day < 32 && month > 0 && month < 13) 
			{
      				var date = new Date(year, month - 1, day);
      				// if the year exists, just use Date.toLocaleString
      				if (year) 
				{
        				date.setFullYear(year);
        				dateStr = date.toLocaleDateString();
      				}
      	
				// if the year doesn't exist, display Month DD (ex. January 01)
      				else
        				dateStr = date.toLocaleFormat(gAddressBookBundle.getString("dateformat"));
    			}
    			else if (year)
      				dateStr = year;
    			visible = cvSetNodeWithLabel(data.cvBirthday, zBirthday, dateStr);

    			visible = cvSetNodeWithLabel(data.cvCustom1, zCustom1,card.getProperty("Custom1")) || visible;
    			visible = cvSetNodeWithLabel(data.cvCustom2, zCustom2,card.getProperty("Custom2")) || visible;
    			visible = cvSetNodeWithLabel(data.cvCustom3, zCustom3,card.getProperty("Custom3")) || visible;
    			visible = cvSetNodeWithLabel(data.cvCustom4, zCustom4,card.getProperty("Custom4")) || visible;
    			visible = cvSetNode(data.cvNotes, card.getProperty("Notes")) || visible;
    			visible = setBuddyIcon(card, data.cvBuddyIcon) || visible;

    			cvSetVisible(data.cvhOther, visible);
    			cvSetVisible(data.cvbOther, visible);

    			// Chat section
    			visible = cvSetNodeWithLabel(data.cvGtalk, zGtalk, card.getProperty("_GoogleTalk"));
    			visible = cvSetNodeWithLabel(data.cvAIM, zAIM, card.getProperty("_AimScreenName")) || visible;
    			visible = cvSetNodeWithLabel(data.cvYahoo, zYahoo, card.getProperty("_Yahoo")) || visible;
    			visible = cvSetNodeWithLabel(data.cvSkype, zSkype, card.getProperty("_Skype")) || visible;
    			visible = cvSetNodeWithLabel(data.cvQQ, zQQ, card.getProperty("_QQ")) || visible;
    			visible = cvSetNodeWithLabel(data.cvMSN, zMSN, card.getProperty("_MSN")) || visible;
    			visible = cvSetNodeWithLabel(data.cvICQ, zICQ, card.getProperty("_ICQ")) || visible;
    			visible = cvSetNodeWithLabel(data.cvXMPP, zXMPP, card.getProperty("_JabberId")) || visible;
    			cvSetVisible(data.cvhChat, visible);
    			cvSetVisible(data.cvbChat, visible);

    			// hide description section, not show for non-mailing lists
    			cvSetVisible(data.cvbDescription, false);

    			// hide addresses section, not show for non-mailing lists
    			cvSetVisible(data.cvbAddresses, false);
  		}

  		// Phone section
  		visible = cvSetNodeWithLabel(data.cvPhWork, zWork, card.getProperty("WorkPhone"));
  		visible = cvSetNodeWithLabel(data.cvPhHome, zHome, card.getProperty("HomePhone")) || visible;
  		visible = cvSetNodeWithLabel(data.cvPhFax, zFax, card.getProperty("FaxNumber")) || visible;
  		visible = cvSetNodeWithLabel(data.cvPhCellular, zCellular, card.getProperty("CellularNumber")) || visible;
  		visible = cvSetNodeWithLabel(data.cvPhPager, zPager, card.getProperty("PagerNumber")) || visible;
  		cvSetVisible(data.cvhPhone, visible);
  		cvSetVisible(data.cvbPhone, visible);
  
		// Work section
  		visible = cvSetNode(data.cvJobTitle, card.getProperty("JobTitle"));
  		visible = cvSetNode(data.cvDepartment, card.getProperty("Department")) || visible;
  		visible = cvSetNode(data.cvCompany, card.getProperty("Company")) || visible;

  		var addressVisible = cvSetNode(data.cvWorkAddress, card.getProperty("WorkAddress"));
  		addressVisible = cvSetNode(data.cvWorkAddress2, card.getProperty("WorkAddress2")) || addressVisible;
  		addressVisible = cvSetCityStateZip(data.cvWorkCityStZip, card.getProperty("WorkCity"), card.getProperty("WorkState"), card.getProperty("WorkZipCode")) || addressVisible;
  		addressVisible = cvSetNode(data.cvWorkCountry, card.getProperty("WorkCountry")) || addressVisible;

        	if (addressVisible) 
		{
          		var workMapItUrl = CreateMapItURL(card.getProperty("WorkAddress"), card.getProperty("WorkAddress2"), card.getProperty("WorkCity"), card.getProperty("WorkState"), card.getProperty("WorkZipCode"), card.getProperty("WorkCountry"));
          		data.cvWorkMapIt.setAttribute('url', workMapItUrl);
          		if (workMapItUrl) 
			{
      				cvSetVisible(data.cvbWorkMapItBox, true);
            			data.cvWorkMapIt.setAttribute('url', workMapItUrl);
          		}
          		else 
			{
      				cvSetVisible(data.cvbWorkMapItBox, false);
          		}
        	}
        	else 
		{
    			cvSetVisible(data.cvbWorkMapItBox, false);
        	}

        	visible = HandleLink(data.cvWorkWebPage, "", card.getProperty("WebPage1"), data.cvWorkWebPageBox, card.getProperty("WebPage1")) || addressVisible || visible;

  		cvSetVisible(data.cvhWork, visible);
  		cvSetVisible(data.cvbWork, visible);

  		// make the card view box visible
  		cvSetVisible(cvData.CardViewBox, true);
	},


	MyClearCardViewPane: function()
	{
		cvSetVisible(cvData.CardViewBox, false);
	},

	open: function()
	{
		document.getElementById('tabmail').openTab('ABTab', {contentPage: 'chrome://messenger/content/addressbook/addressbook.xul', image: "chrome://AddressBookTab/skin/btn_small.png"});
	},
	
	MyDirPaneSelectionChange: function()
	{
		// clear out the search box when changing folders...
		onAbClearSearch();
		if (gDirTree && gDirTree.view.selection && gDirTree.view.selection.count == 1)
		{
			gPreviousDirTreeIndex = gDirTree.currentIndex;
			ChangeDirectoryByURI(GetSelectedDirectory());
			var branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

			if( branch.getBoolPref( "extensions.addressbooktab.dirtitle" )&&( this.top.name != "" )) 
				document.title = GetDirectoryFromURI(GetSelectedDirectory()).dirName;
		}
		goUpdateCommand('cmd_newlist');
	}
}

var ABTabType = {
	name: "ABTab",
    perTabPanel: "vbox",
    lastBrowserId: 0,
    get loadingTabString() {
		delete this.loadingTabString;
		return this.loadingTabString = document.getElementById("bundle_messenger")
										.getString("loadingTab");
    },

	modes: {
		ABTab: {
			type: "ABTab",
			maxTabs: 10,
		}
	},
	shouldSwitchTo: function onSwitchTo({contentPage: aContentPage}) {	
		var branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	    if( branch.getBoolPref( "extensions.addressbooktab.multi" )) return -1;
		let tabmail = document.getElementById("tabmail");
		let tabInfo = tabmail.tabInfo;

		// Remove any anchors - especially for the about: pages, we just want
		// to re-use the same tab.
		let regEx = new RegExp("#.*");

		let contentUrl = aContentPage.replace(regEx, "");

		for (let selectedIndex = 0; selectedIndex < tabInfo.length; ++selectedIndex) {
			if (tabInfo[selectedIndex].mode.name == this.name &&
				tabInfo[selectedIndex].browser.currentURI.spec
				.replace(regEx, "") == contentUrl) {
			// Ensure we go to the correct location on the page.
				tabInfo[selectedIndex].browser.setAttribute("src", aContentPage);
				return selectedIndex;
			}
		}
		return -1;
	},
	
	openTab: function onTabOpened(aTab, aArgs) {
		if (!"contentPage" in aArgs)
			throw("contentPage must be specified");

		// First clone the page and set up the basics.
		let clone = document.getElementById("contentTab").firstChild.cloneNode(true);

		clone.setAttribute("id", "ABTab" + this.lastBrowserId);
		clone.setAttribute("collapsed", false);

		aTab.panel.appendChild(clone);

		// Start setting up the browser.
		aTab.browser = aTab.panel.getElementsByTagName("browser")[0];

		// As we're opening this tab, showTab may not get called, so set
		// the type according to if we're opening in background or not.
		let background = ("background" in aArgs) && aArgs.background;
		aTab.browser.setAttribute("type", background ? "content-targetable" :
													 "content-primary");

		aTab.browser.setAttribute("id", "ABTabBrowser" + this.lastBrowserId);

		aTab.browser.setAttribute("onclick",
			"clickHandler" in aArgs && aArgs.clickHandler ?
			aArgs.clickHandler : "specialTabs.defaultClickHandler(event);");

		// Now initialise the find bar.
		aTab.findbar = aTab.panel.getElementsByTagName("findbar")[0];
		aTab.findbar.setAttribute("browserid", "ABTabBrowser" + this.lastBrowserId);

		// Default to reload being disabled.
		aTab.reloadEnabled = false;
		
		// Set tabNode attibute
        aTab.tabNode.setAttribute("TabType","AddressBook");		
        aTab.tabNode.setAttribute("image","chrome://AddressBookTab/skin/btn_small.png") ;
		
		// Now set up the listeners.
		this._setUpTitleListener(aTab);
		this._setUpCloseWindowListener(aTab);

		// Create a filter and hook it up to our browser
		let filter = Components.classes["@mozilla.org/appshell/component/browser-status-filter;1"]
							 .createInstance(Components.interfaces.nsIWebProgress);
		aTab.filter = filter;
		aTab.browser.webProgress.addProgressListener(filter, Components.interfaces.nsIWebProgress.NOTIFY_ALL);

		// Wire up a progress listener to the filter for this browser
		aTab.progressListener = new tabProgressListener(aTab, false);

		filter.addProgressListener(aTab.progressListener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);

		// Now start loading the content.
		aTab.title = this.loadingTabString;

		aTab.browser.loadURI(aArgs.contentPage);

//		aTab.browser.addEventListener( "load", function(e) {
//			if( "folderInd" in aArgs) 
//			{
//				aTab.browser.contentWindow.dirTree.builder.root.view.selection.select(aArgs.folderInd);
//			}
//		}, false);
		
        //Change folder in case of reload
		if( "folderInd" in aArgs) 
		{
			aTab.browser.addEventListener("DOMContentLoaded", function(e) {
				aTab.browser.contentWindow.dirTree.builder.root.view.selection.select(aArgs.folderInd);
			}, false);
		}

		this.lastBrowserId++;
	},
	
	closeTab: function onTabClosed(aTab) {
		aTab.browser.removeEventListener("DOMTitleChanged",
									   aTab.titleListener, true);
		aTab.browser.removeEventListener("DOMWindowClose",
									   aTab.closeListener, true);
		aTab.browser.webProgress.removeProgressListener(aTab.filter);
		aTab.filter.removeProgressListener(aTab.progressListener);
		aTab.browser.destroy();
	},
	
	saveTabState: function onSaveTabState(aTab) {
		aTab.browser.setAttribute("type", "content-targetable");
	},
	
	showTab: function onShowTab(aTab) {
		aTab.browser.setAttribute("type", "content-primary");
	},
	
	persistTab: function onPersistTab(aTab) {
		if (aTab.browser.currentURI.spec == "about:blank")
		return null;

		let onClick = aTab.browser.getAttribute("onclick");
		
		return {
			tabURI: aTab.browser.currentURI.spec,
			clickHandler: onClick ? onClick : null,
/*			folderInd: aTab.browser.contentWindow.dirTree.currentIndex*/
		};
	},
	
	restoreTab: function onRestoreTab(aTabmail, aPersistedState) {
		aTabmail.openTab("ABTab", { contentPage: aPersistedState.tabURI,
									   clickHandler: aPersistedState.clickHandler,
/*									   folderInd: aPersistedState.folderInd,*/
									   background: true } );
	},
	
	
	supportsCommand: function supportsCommand(aCommand, aTab) {
		switch (aCommand) {
			case "cmd_fullZoomReduce":
			case "cmd_fullZoomEnlarge":
			case "cmd_fullZoomReset":
			case "cmd_fullZoomToggle":
			case "cmd_find":
			case "cmd_findAgain":
			case "cmd_findPrevious":
			case "cmd_printSetup":
			case "cmd_print":
			case "button_print":
			case "cmd_stop":
			case "cmd_reload":
			// XXX print preview not currently supported - bug 497994 to implement.
			// case "cmd_printpreview":
				return true;
			default:
				return false;
		}
	},
	
	isCommandEnabled: function isCommandEnabled(aCommand, aTab) {
		switch (aCommand) {
			case "cmd_fullZoomReduce":
			case "cmd_fullZoomEnlarge":
			case "cmd_fullZoomReset":
			case "cmd_fullZoomToggle":
			case "cmd_find":
			case "cmd_findAgain":
			case "cmd_findPrevious":
			case "cmd_printSetup":
			case "cmd_print":
			case "button_print":
			// XXX print preview not currently supported - bug 497994 to implement.
			// case "cmd_printpreview":
				return true;
			case "cmd_reload":
				return aTab.reloadEnabled;
			case "cmd_stop":
				return aTab.busy;
			default:
				return false;
		}
	},
	
	doCommand: function isCommandEnabled(aCommand, aTab) {
		switch (aCommand) {
			case "cmd_fullZoomReduce":
				ZoomManager.reduce();
				break;
			case "cmd_fullZoomEnlarge":
				ZoomManager.enlarge();
				break;
			case "cmd_fullZoomReset":
				ZoomManager.reset();
				break;
			case "cmd_fullZoomToggle":
				ZoomManager.toggleZoom();
				break;
			case "cmd_find":
				aTab.findbar.onFindCommand();
				break;
			case "cmd_findAgain":
				aTab.findbar.onFindAgainCommand(false);
				break;
			case "cmd_findPrevious":
				aTab.findbar.onFindAgainCommand(true);
				break;
			case "cmd_printSetup":
				PrintUtils.showPageSetup();
				break;
			case "cmd_print":
				PrintUtils.print();
				break;
			// XXX print preview not currently supported - bug 497994 to implement.
			//case "cmd_printpreview":
			//  PrintUtils.printPreview();
			//  break;
			case "cmd_stop":
				aTab.browser.stop();
				break;
			case "cmd_reload":
				aTab.browser.reload();
			break;
		}
	},
	
	getBrowser: function getBrowser(aTab) {
		return aTab.browser;
	},
	
	// Internal function used to set up the title listener on a content tab.
	_setUpTitleListener: function setUpTitleListener(aTab) {
		function onDOMTitleChanged(aEvent) {
			aTab.title = aTab.browser.contentTitle;
			document.getElementById("tabmail").setTabTitle(aTab);
		}
		// Save the function we'll use as listener so we can remove it later.
		aTab.titleListener = onDOMTitleChanged;
		// Add the listener.
		aTab.browser.addEventListener("DOMTitleChanged",
									aTab.titleListener, true);
	},
	
	/**
	 * Internal function used to set up the close window listener on a content
	 * tab.
	 */
	_setUpCloseWindowListener: function setUpCloseWindowListener(aTab) {
		function onDOMWindowClose(aEvent) {
			if (!aEvent.isTrusted)
				return;

			// Redirect any window.close events to closing the tab. As a 3-pane tab
			// must be open, we don't need to worry about being the last tab open.
			document.getElementById("tabmail").closeTab(aTab);
			aEvent.preventDefault();
		}
		// Save the function we'll use as listener so we can remove it later.
		aTab.closeListener = onDOMWindowClose;
		// Add the listener.
		aTab.browser.addEventListener("DOMWindowClose",
									aTab.closeListener, true);
	}
};

window.addEventListener("load", function(e) {
    let tabmail = document.getElementById('tabmail');
    if( tabmail ) tabmail.registerTabType(ABTabType);
}, false);


GoIM = ABTab.MyGoIM;
DisplayCardViewPane = ABTab.MyDisplayCardViewPane;
ClearCardViewPane = ABTab.MyClearCardViewPane;
DirPaneSelectionChange = ABTab.MyDirPaneSelectionChange;
