var ABTabBt = {
 
	init: function()
	{
		window.removeEventListener("load", ABTabBt.init, false);
		window.addEventListener("unload", ABTabBt.finish, false);
		ABTabBt.cleanupPrefs();             // Clear any pref entries from old versions
		ABTabBt.ModeBarIco();
		ABTabBt.prefObserver.register();  // Listen for preferences changes
	},

	finish: function()
	{
		window.removeEventListener("unload", ABTabBt.finish, false);
		ABTabBt.prefObserver.unregister();
	},

	prefObserver:
	{
		branch: null,  // the pref branch we're observing

		register: function()
		{
			this.branch = Components.classes["@mozilla.org/preferences-service;1"]
							.getService(Components.interfaces.nsIPrefService)
							.getBranch("extensions.addressbooktab.");
			this.branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
			this.branch.addObserver("", this, false);
		},

		unregister: function()
		{
			if (this.branch != null)
			this.branch.removeObserver("", this);
		},

		observe: function(aSubject, aTopic, aData)
		{
			if (aTopic != "nsPref:changed") return;
			switch (aData)
			{
				case "modebar":
					ABTabBt.ModeBarIco();
					break;
			}
		}
	},

	ModeBarIco: function()
	{
		var modebar = document.getElementById("tabmail-buttons");
		var ABTabBar = document.getElementById("ABTabBar");
		var branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var gBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
		var Loctxt = gBundle.createBundle("chrome://AddressBookTab/locale/AddressBookTab.properties");

		var isCheck = branch.getBoolPref( "extensions.addressbooktab.modebar" );
		if( isCheck && !ABTabBar )
		{
			ABTabBar = document.createElement( "toolbarbutton" );
			ABTabBar.setAttribute("id", "ABTabBar" );
			ABTabBar.setAttribute("oncommand", "ABTab.open();" );
			ABTabBar.setAttribute("tooltiptext", Loctxt.GetStringFromName("ModeBarTooltip"));
			modebar.appendChild( ABTabBar, null);
		}
		else if( !isCheck && ABTabBar )
		{
			modebar.removeChild( ABTabBar );
		}
	},

	cleanupPrefs: function()  // Wipes all AddressBookTab preferences that do not have defaults
	{
		/* Both the user and default branches contain the exact same list of pref names,
		even if any default values don't exist or any user values equal the default. */
		var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
		var defaultBranch = prefService.getDefaultBranch("extensions.addressbooktab.");
		var userBranch = prefService.getBranch("extensions.addressbooktab.");
		var prefsList = userBranch.getChildList("",{});
		if (!prefsList.length)
			throw "Could not load AddressBookTab preferences list";
		for (var i in prefsList)
		{   // Exception means no default exists and this pref is not in use
			try { defaultBranch.getBoolPref(prefsList[i]); }
			catch (e) { userBranch.clearUserPref(prefsList[i]); }
		}
	},
}

window.addEventListener("load", ABTabBt.init, false);